## keystone 17.0.1

=== requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.

pbr!=2.1.0,>=2.0.0 # Apache-2.0
WebOb>=1.7.1 # MIT
Flask!=0.11,>=1.0.2  # BSD
Flask-RESTful>=0.3.5  # BSD
cryptography>=2.1 # BSD/Apache-2.0
SQLAlchemy>=1.1.0 # MIT
sqlalchemy-migrate>=0.11.0 # Apache-2.0
stevedore>=1.20.0 # Apache-2.0
passlib>=1.7.0 # BSD
python-keystoneclient>=3.8.0 # Apache-2.0
keystonemiddleware>=7.0.0 # Apache-2.0
bcrypt>=3.1.3 # Apache-2.0
scrypt>=0.8.0 # BSD
oslo.cache>=1.26.0 # Apache-2.0
oslo.config>=5.2.0 # Apache-2.0
oslo.context>=2.22.0 # Apache-2.0
oslo.messaging>=5.29.0 # Apache-2.0
oslo.db>=4.27.0 # Apache-2.0
oslo.i18n>=3.15.3 # Apache-2.0
oslo.log>=3.44.0 # Apache-2.0
oslo.middleware>=3.31.0 # Apache-2.0
oslo.policy>=3.0.2 # Apache-2.0
oslo.serialization!=2.19.1,>=2.18.0 # Apache-2.0
oslo.upgradecheck>=0.1.0 # Apache-2.0
oslo.utils>=3.33.0 # Apache-2.0
oauthlib>=0.6.2 # BSD
pysaml2>=4.5.0
PyJWT>=1.6.1 # MIT
dogpile.cache>=0.6.2 # BSD
jsonschema>=2.6.0 # MIT
pycadf!=2.0.0,>=1.1.0 # Apache-2.0
msgpack>=0.5.0 # Apache-2.0
osprofiler>=1.4.0 # Apache-2.0
pytz>=2013.6 # MIT

=== doc/requirements.txt ===
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.
openstackdocstheme>=1.20.0 # Apache-2.0
sphinx!=1.6.6,!=1.6.7,!=2.1.0,>=1.6.2  # BSD
sphinxcontrib-apidoc>=0.2.0  # BSD
sphinxcontrib-seqdiag>=0.8.4  # BSD
sphinx-feature-classification>=0.3.2  # Apache-2.0
sphinxcontrib-blockdiag>=1.5.5  # BSD
reno>=2.5.0 # Apache-2.0
os-api-ref>=1.4.0 # Apache-2.0
python-ldap>=3.0.0  # PSF
ldappool>=2.0.0 # MPL

=== debian/changelog ===
keystone (2:17.0.1-0ubuntu2) focal; urgency=medium

  * d/p/lp1998789-pooledldap-conn-release-on-exception.patch: Release
    pooled ldap connection back to pool when an exception is thrown
    by ldap methods (LP: #1998789).

 -- Mustafa Kemal GILOR <mustafa.gilor@canonical.com>  Wed, 04 Oct 2023 12:29:32 +0300

keystone (2:17.0.1-0ubuntu1) focal; urgency=medium

  * d/control: Update VCS paths for move to lp:~ubuntu-openstack-dev.
  * d/watch: Add trailing slash to URL.
  * New stable point release for OpenStack Ussuri (LP: #1943712).

 -- Chris MacNaughton <chris.macnaughton@ubuntu.com>  Fri, 17 Sep 2021 10:05:08 +0000

keystone (2:17.0.0-0ubuntu0.20.04.1) focal; urgency=medium

  * d/watch: Scope to 17.x series and get tarballs from opendev.org.
  * d/control: Align (Build-)Depends with upstream.
  * d/p/update-babel-requirement.txt: Dropped now that Babel has been
    dropped from upstream requirements.txt.
  * New upstream release for OpenStack Ussuri (LP: #1877642).
  * d/gbp.conf: Create stable/ussuri branch.

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 13 May 2020 17:10:34 -0400

=== debian/control ===
Source: keystone
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Monty Taylor <mordred@inaugust.com>
Build-Depends:
 apache2-dev,
 debhelper (>= 10~),
 dh-apache2,
 dh-python,
 openstack-pkg-tools (>= 85ubuntu3~),
 python3-all,
 python3-pbr (>= 2.0.0),
 python3-setuptools,
 python3-sphinx (>= 1.6.2),
 python3-sphinx-feature-classification (>= 0.3.2),
Build-Depends-Indep:
 crudini,
 python3-bashate (>= 0.5.1),
 python3-bcrypt (>= 3.1.3),
 python3-coverage (>= 4.0),
 python3-cryptography (>= 2.1),
 python3-dogpile.cache (>= 0.6.2),
 python3-fixtures (>= 3.0.0),
 python3-flake8-docstrings (>= 0.2.1.post1),
 python3-flask (>= 1.0.2),
 python3-flask-restful (>= 0.3.5),
 python3-freezegun (>= 0.3.6),
 python3-hacking (>= 1.1.0),
 python3-jsonschema (>= 2.6.0),
 python3-jwt (>= 1.6.1),
 python3-keystoneclient (>= 1:3.8.0),
 python3-keystonemiddleware (>= 7.0.0),
 python3-ldap (>= 3.0.0),
 python3-ldappool (>= 2.0.0),
 python3-lxml (>= 3.4.1),
 python3-memcache,
 python3-migrate (>= 0.11.0),
 python3-mock (>= 2.0.0),
 python3-msgpack (>= 0.5.0),
 python3-oauthlib (>= 0.6.2),
 python3-openstackdocstheme (>= 1.20.0),
 python3-os-api-ref (>= 1.4.0),
 python3-os-testr (>= 1.0.0),
 python3-oslo.cache (>= 1.26.0),
 python3-oslo.config (>= 1:5.2.0),
 python3-oslo.context (>= 1:2.22.0),
 python3-oslo.db (>= 4.27.0),
 python3-oslo.i18n (>= 3.15.3),
 python3-oslo.log (>= 3.44.0),
 python3-oslo.messaging (>= 5.29.0),
 python3-oslo.middleware (>= 3.31.0),
 python3-oslo.policy (>= 3.0.2),
 python3-oslo.serialization (>= 2.18.0),
 python3-oslo.upgradecheck (>= 0.1.0),
 python3-oslo.utils (>= 3.33.0),
 python3-oslotest (>= 1:3.2.0),
 python3-osprofiler (>= 1.4.0),
 python3-passlib (>= 1.7.0),
 python3-paste (>= 2.0.2),
 python3-pastedeploy (>= 1.5.0),
 python3-pep8,
 python3-pycadf (>= 1.1.0),
 python3-pycodestyle (>= 2.0.0),
 python3-pymongo,
 python3-pymysql,
 python3-pysaml2 (>= 4.5.0),
 python3-reno (>= 2.5.0),
 python3-requests (>= 2.14.2),
 python3-scrypt (>= 0.8.0),
 python3-sphinxcontrib.apidoc (>= 0.2.0),
 python3-sphinxcontrib.blockdiag (>= 1.5.5),
 python3-sphinxcontrib.seqdiag (>= 0.8.4),
 python3-sqlalchemy (>= 1.1.0),
 python3-stestr (>= 1.0.0),
 python3-stevedore (>= 1:1.20.0),
 python3-tempest (>= 1:17.1.0),
 python3-testresources (>= 2.0.0),
 python3-testtools (>= 2.2.0),
 python3-tz (>= 2013.6),
 python3-webob (>= 1:1.7.1),
 python3-webtest (>= 2.0.27),
Standards-Version: 4.1.4
XS-Python-Version: >= 2.7
Homepage: https://launchpad.net/keystone
Vcs-Browser: https://git.launchpad.net/~ubuntu-openstack-dev/ubuntu/+source/keystone
Vcs-Git: https://git.launchpad.net/~ubuntu-openstack-dev/ubuntu/+source/keystone
Testsuite: autopkgtest-pkg-python

Package: keystone
Architecture: all
Section: python
Depends:
 adduser,
 apache2 | httpd,
 libapache2-mod-wsgi-py3,
 python3-keystone (= ${source:Version}),
 ssl-cert (>= 1.0.12),
 ${misc:Depends},
Recommends:
 ${misc:Recommends},
Description: OpenStack identity service - Daemons
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the daemons.

Package: keystone-common
Architecture: all
Section: python
Depends:
 ${misc:Depends},
Breaks:
 keystone (<< 2:14.0.0~b2-0ubuntu2~),
Replaces:
 keystone (<< 2:14.0.0~b2-0ubuntu2~),
Description: OpenStack identity service - Common files
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the common files.

Package: keystone-doc
Architecture: all
Section: doc
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: OpenStack identity service - Documentation
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the documentation.

Package: python3-keystone
Architecture: all
Section: python
Depends:
 keystone-common (= ${source:Version}),
 python3-bcrypt (>= 3.1.3),
 python3-cryptography (>= 2.1),
 python3-dogpile.cache (>= 0.6.2),
 python3-flask (>= 1.0.2),
 python3-flask-restful (>= 0.3.5),
 python3-jsonschema (>= 2.6.0),
 python3-jwt (>= 1.6.1),
 python3-keystoneclient (>= 1:3.8.0),
 python3-keystonemiddleware (>= 7.0.0),
 python3-ldap,
 python3-migrate (>= 0.11.0),
 python3-msgpack (>= 0.5.0),
 python3-oauthlib (>= 0.6.2),
 python3-oslo.cache (>= 1.26.0),
 python3-oslo.config (>= 1:5.2.0),
 python3-oslo.context (>= 1:2.22.0),
 python3-oslo.db (>= 4.27.0),
 python3-oslo.i18n (>= 3.15.3),
 python3-oslo.log (>= 3.44.0),
 python3-oslo.messaging (>= 5.29.0),
 python3-oslo.middleware (>= 3.31.0),
 python3-oslo.policy (>= 3.0.2),
 python3-oslo.serialization (>= 2.18.0),
 python3-oslo.upgradecheck (>= 0.1.0),
 python3-oslo.utils (>= 3.33.0),
 python3-osprofiler (>= 1.4.0),
 python3-passlib (>= 1.7.0),
 python3-paste (>= 2.0.2),
 python3-pastedeploy (>= 1.5.0),
 python3-pbr (>= 2.0.0),
 python3-pycadf (>= 1.1.0),
 python3-pymysql,
 python3-pysaml2 (>= 4.5.0),
 python3-scrypt (>= 0.8.0),
 python3-sqlalchemy (>= 1.1.0),
 python3-stevedore (>= 1:1.20.0),
 python3-tz (>= 2013.6),
 python3-webob (>= 1:1.7.1),
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 python3-ldappool (>= 2.0.0),
 python3-memcache,
Provides:
 ${python3:Provides},
XB-Python-Version: ${python3:Versions}
Description: OpenStack identity service - Python 3 library
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the Python 3 libraries.

=== debian/watch ===
version=3
opts="uversionmangle=s/\.([a-zA-Z])/~$1/;s/%7E/~/;s/\.0b/~b/;s/\.0rc/~rc/" \
 https://tarballs.opendev.org/openstack/keystone/ keystone-(17\.\d.*)\.tar\.gz

## keystone 18.0.0

=== debian/changelog ===
keystone (2:18.0.0-3+deb11u1) bullseye; urgency=medium

  * Tune keystone-uwsgi.ini for performance.
  * CVE-2021-38155 / OSSA-2021-003: Account name and UUID oracles in account
    locking. Applied upstream patch: Hide AccountLocked exception from end
    users (Closes: #992070).

 -- Thomas Goirand <zigo@debian.org>  Wed, 17 Mar 2021 12:06:20 +0100

keystone (2:18.0.0-3) unstable; urgency=medium

  * Removed python3-crypto from (build-)depends (Closes: #971310).

 -- Thomas Goirand <zigo@debian.org>  Sat, 21 Nov 2020 23:09:55 +0100

keystone (2:18.0.0-2) unstable; urgency=medium

  * Call "keystone-manage fernet_setup" when a user requests to bootstrap the
    keystone/create-admin-tenant, rather than the db (Closes: #973931).

 -- Thomas Goirand <zigo@debian.org>  Sat, 21 Nov 2020 00:26:16 +0100

keystone (2:18.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Add debian/salsa-ci.yml.
  * Fixed watch file.
  * Uploading to unstable.
  * Blacklist all of NotificationsTestCase which isn't deterministic.

 -- Thomas Goirand <zigo@debian.org>  Mon, 12 Oct 2020 14:00:26 +0200

keystone (2:18.0.0~rc1-1) experimental; urgency=medium

  * New upstream release.
  * Fixed (build-)depends for this release.
  * Switched to using /etc/keystone/policy.d/00_default_policy.yaml policy
    file instead of json.

 -- Thomas Goirand <zigo@debian.org>  Fri, 25 Sep 2020 13:56:56 +0200

keystone (2:17.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Thomas Goirand <zigo@debian.org>  Wed, 13 May 2020 16:55:38 +0200

keystone (2:17.0.0~rc2-1) unstable; urgency=medium

  * New upstream release.
    - Includes fixes for multiple CVE: CVE-2020-12689 CVE-2020-12690
      CVE-2020-12691 CVE-2020-12692 (Closes: #959900).
  * Uploading to unstable.
  * Update it.po debconf translation (Closes: #952795).

 -- Thomas Goirand <zigo@debian.org>  Sat, 09 May 2020 00:14:15 +0200

keystone (2:17.0.0~rc1-1) experimental; urgency=medium

  * New upstream release.
  * Fixed (build-)depends for this release.
  * Kill useless or applied upstream patches:
    - allow-babel-2.4.0.patch
    - CVE-2019-19687_Fix_credential_list_for_project_members.patch

 -- Thomas Goirand <zigo@debian.org>  Fri, 24 Apr 2020 12:18:15 +0200

keystone (2:16.0.0-6) unstable; urgency=medium

  * Fallsback to hostname -i when detecting IP, and do not crash if we can't
    find one.

 -- Thomas Goirand <zigo@debian.org>  Fri, 13 Mar 2020 16:04:35 +0100

=== debian/control ===
Source: keystone
Section: net
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
 Michal Arbet <michal.arbet@ultimum.io>,
Build-Depends:
 debhelper-compat (= 10),
 dh-apparmor,
 dh-python,
 openstack-pkg-tools (>= 99~),
 po-debconf,
 python3-all,
 python3-pbr,
 python3-setuptools,
 python3-sphinx,
Build-Depends-Indep:
 git,
 python3-bashate,
 python3-bcrypt,
 python3-coverage,
 python3-cryptography (>= 2.7),
 python3-dogpile.cache (>= 1.0.2),
 python3-fixtures,
 python3-flask,
 python3-flask-restful,
 python3-freezegun,
 python3-hacking,
 python3-jsonschema (>= 3.2.0),
 python3-jwt,
 python3-keystoneclient,
 python3-keystonemiddleware (>= 7.0.0),
 python3-ldap,
 python3-ldappool,
 python3-lxml (>= 4.5.0),
 python3-memcache,
 python3-migrate (>= 0.13.0),
 python3-msgpack,
 python3-oauthlib,
 python3-openstackdocstheme,
 python3-os-api-ref,
 python3-oslo.cache,
 python3-oslo.config (>= 1:8.0.2),
 python3-oslo.context (>= 2.22.1),
 python3-oslo.db (>= 6.0.0),
 python3-oslo.i18n,
 python3-oslo.log (>= 3.44.0),
 python3-oslo.messaging (>= 12.1.0),
 python3-oslo.middleware,
 python3-oslo.policy (>= 3.0.2),
 python3-oslo.serialization,
 python3-oslo.upgradecheck,
 python3-oslo.utils,
 python3-oslotest,
 python3-osprofiler,
 python3-passlib,
 python3-pep8,
 python3-pycadf,
 python3-pymongo,
 python3-pysaml2 (>= 5.0.0),
 python3-requests,
 python3-scrypt,
 python3-sphinx-feature-classification,
 python3-sphinxcontrib.apidoc,
 python3-sphinxcontrib.blockdiag,
 python3-sphinxcontrib.seqdiag,
 python3-sqlalchemy (>= 1.3.0),
 python3-stestr,
 python3-stevedore,
 python3-tempest,
 python3-testresources,
 python3-testscenarios,
 python3-testtools,
 python3-tz,
 python3-unittest2,
 python3-webob,
 python3-webtest,
 subunit,
 tempest,
Standards-Version: 4.4.1
Homepage: http://keystone.openstack.org/
Vcs-Browser: https://salsa.debian.org/openstack-team/services/keystone
Vcs-Git: https://salsa.debian.org/openstack-team/services/keystone.git

Package: keystone
Architecture: all
Depends:
 adduser,
 dbconfig-common,
 debconf,
 python3-keystone (= ${source:Version}),
 python3-keystoneclient,
 python3-openstackclient,
 python3-pastescript,
 q-text-as-data,
 sqlite3,
 uwsgi-plugin-apparmor,
 uwsgi-plugin-python3 (>= 2.0.18),
 ${misc:Depends},
 ${ostack-lsb-base},
 ${python3:Depends},
Suggests:
 apparmor,
Description: OpenStack identity service
 This is the identity service used by OpenStack for authentication (authN)
 and high-level authorization (authZ). It currently supports token-based
 authN with user/service authZ, and is scalable to support OAuth, SAML,
 and OpenID in future versions. Out of the box, Keystone uses SQLite for
 its identity store database, with the option to connect to external LDAP.
 .
 This package contains the daemons.

Package: keystone-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Description: OpenStack identity service - documentation
 This is the identity service used by OpenStack for authentication (authN)
 and high-level authorization (authZ). It currently supports token-based
 authN with user/service authZ, and is scalable to support OAuth, SAML,
 and OpenID in future versions. Out of the box, Keystone uses SQLite for
 its identity store database, with the option to connect to external LDAP.
 .
 This package contains the documentation.

Package: python3-keystone
Architecture: all
Section: python
Depends:
 python3-bcrypt,
 python3-cryptography (>= 2.7),
 python3-dateutil,
 python3-dogpile.cache (>= 1.0.2),
 python3-flask,
 python3-flask-restful,
 python3-jsonschema (>= 3.2.0),
 python3-jwt,
 python3-keystoneclient,
 python3-keystonemiddleware (>= 7.0.0),
 python3-ldappool,
 python3-lxml (>= 4.5.0),
 python3-memcache,
 python3-migrate (>= 0.13.0),
 python3-msgpack,
 python3-oauthlib,
 python3-openstackclient,
 python3-oslo.cache,
 python3-oslo.config (>= 1:8.0.2),
 python3-oslo.context (>= 2.22.1),
 python3-oslo.db (>= 6.0.0),
 python3-oslo.i18n,
 python3-oslo.log (>= 3.44.0),
 python3-oslo.messaging (>= 12.1.0),
 python3-oslo.middleware,
 python3-oslo.policy (>= 3.0.2),
 python3-oslo.serialization,
 python3-oslo.upgradecheck,
 python3-oslo.utils,
 python3-osprofiler,
 python3-passlib,
 python3-pbr,
 python3-pycadf,
 python3-pyldap,
 python3-pymysql,
 python3-pysaml2 (>= 5.0.0),
 python3-scrypt,
 python3-sqlalchemy (>= 1.3.0),
 python3-stevedore,
 python3-tz,
 python3-webob,
 ${misc:Depends},
 ${python3:Depends},
Conflicts:
 python-keystone,
Description: OpenStack identity service - library
 This is the identity service used by OpenStack for authentication (authN)
 and high-level authorization (authZ). It currently supports token-based
 authN with user/service authZ, and is scalable to support OAuth, SAML,
 and OpenID in future versions. Out of the box, Keystone uses SQLite for
 its identity store database, with the option to connect to external LDAP.
 .
 This package contains the Python libraries.

## keystone 18.1.0

=== debian/changelog ===
keystone (2:18.1.0-1+deb11u2) bullseye-security; urgency=medium

  * New upstream release.
  * Removed CVE-2021-38155_Hide_AccountLocked_exception_from_end_users.patch
    now upstreamed.
  * OSSA-2025-002: kay reported a vulnerability in Keystone’s ec2tokens and
    s3tokens APIs. By sending those endpoints a valid AWS Signature (e.g., from
    a presigned S3 URL), an unauthenticated attacker may obtain Keystone
    authorization (ec2tokens can yield a fully scoped token; s3tokens can
    reveal scope accepted by some services), resulting in unauthorized access
    and privilege escalation. Deployments where /v3/ec2tokens or /v3/s3tokens
    are reachable by unauthenticated clients (e.g., exposed on a public API)
    are affected.
    Applied upstream patch (Closes: #1120053):
    - Fix_oslo_policy_DeprecatedRule_warnings.patch
    - Consistent_and_Secure_RBAC_Phase_1.patch
    - Fix_policies_for_groups.patch
    - Allow_admin_to_access_tokens_and_credentials.patch
    - Dont_enforce_when_HTTP_GET_on_s3tokens_and_ec2tokens.patch
    - keystone-bug-2119646-stable-2024.1.patch (backported by me)
    - compat-with-oslo.policy-3.5.0.patch

 -- Thomas Goirand <zigo@debian.org>  Fri, 31 Oct 2025 00:56:54 +0100

=== debian/rules ===
#!/usr/bin/make -f

# auth_token middleware now requires access to HOME, otherwise
# test suite cause FTBFS.  See (LP: #1031022)
export HOME="$(CURDIR)/debian/tests/"

# This is to avoid git clone of keystoneclient when running unit tests.
# See https://review.openstack.org/122768/
export KSCTEST_PATH=/usr/lib/python3/dist-packages/keystoneclient

include /usr/share/openstack-pkg-tools/pkgos.make

%:
	dh $@ --buildsystem=python_distutils --with python3,sphinxdoc,systemd

override_dh_clean:
	rm -rf $(CURDIR)/build $(CURDIR)/keystone.egg-info $(CURDIR)/.cache
	rm -rf $(CURDIR)/keystone/test/keystone.sql.log $(CURDIR)/keystone/test/keystone.ldap.log
	rm -rf $(CURDIR)/doc/build
	# NOTE(adam_g) The following stuff is built in /doc/source.  Safe for now, but
	# should be fixed upstream or updated here post-essex
	rm -rf $(CURDIR)/doc/source/keystone*.rst
	rm -rf $(CURDIR)/doc/source/modules.rst
	rm -rf $(CURDIR)/doc/source/sourcecode $(CURDIR)/doc/source/api
	rm -f $(CURDIR)/doc/source/_static/keystone.conf.sample
	rm -f $(CURDIR)/doc/source/_static/keystone.policy.yaml.sample
	rm -rf $(CURDIR)/admin.log $(CURDIR)/keystone-legacy-auth.log
	rm -f $(CURDIR)/debian/keystone.config $(CURDIR)/debian/keystone.postinst
	find $(CURDIR)/keystone/tests -name '*.db' -delete
	rm -rf $(CURDIR)/vendor
	rm -rf $(CURDIR)/.stestr
	rm -f $(CURDIR)/debian/tests/testing.db
	rm -f $(CURDIR)/debian/keystone.keystone*.init $(CURDIR)/debian/keystone.keystone*.service $(CURDIR)/debian/keystone.keystone*.upstart
	find $(CURDIR) -name '*.pyc' -delete
	rm -f AUTHORS ChangeLog
	dh_clean

override_dh_auto_build:
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func keystone.config
	/usr/share/openstack-pkg-tools/pkgos_insert_include pkgos_func keystone.postinst

override_dh_auto_clean:
	python3 setup.py clean

override_dh_auto_test:
	echo "Do nothing..."

override_dh_auto_install:
	echo "Doing nothing..."

override_dh_install:
	for i in $(PYTHON3S) ; do \
		PYTHON=python$$i python$$i setup.py install --install-layout=deb --root $(CURDIR)/debian/tmp ; \
	done

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	@echo "===> Running tests"
	mkdir -p $(CURDIR)/keystone/tests/tmp
	pkgos-dh_auto_test --no-py2 'keystone\.tests\.unit.(?!(.*test_v3_federation\.SAMLGenerationTests\.test_sign_assertion_exc.*|.*test_sql_upgrade.FullMigration.*|.*test_hacking_checks\.TestCheckForMutableDefaultArgs\.test.*|.*common\.test_notifications\.NotificationsTestCase.*))'
endif

	rm -rf $(CURDIR)/debian/tmp/usr/etc
	dh_install
	dh_missing --fail-missing
	rm -rf debian/python3-keystone/usr/lib/python*/*/doc
	rm -rf debian/python3-keystone/usr/lib/python*/*/tools
	rm -rf debian/python3-keystone/usr/lib/python*/*/examples
	install -D -m 0600 $(CURDIR)/debian/logging.conf $(CURDIR)/debian/keystone/etc/keystone/logging.conf
	mkdir -p $(CURDIR)/debian/keystone/usr/share/keystone
	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages oslo-config-generator \
		--output-file $(CURDIR)/debian/keystone/usr/share/keystone/keystone.conf \
		--wrap-width 140 \
		--namespace keystone \
		--namespace oslo.cache \
		--namespace oslo.log \
		--namespace oslo.messaging \
		--namespace oslo.policy \
		--namespace oslo.db \
		--namespace oslo.middleware \
		--namespace osprofiler
	pkgos-fix-config-default $(CURDIR)/debian/keystone/usr/share/keystone/keystone.conf catalog template_file /etc/keystone/default_catalog.templates
	pkgos-fix-config-default $(CURDIR)/debian/keystone/usr/share/keystone/keystone.conf DEFAULT log_dir /var/log/keystone
	pkgos-fix-config-default $(CURDIR)/debian/keystone/usr/share/keystone/keystone.conf DEFAULT log_file keystone.log

	mkdir -p $(CURDIR)/debian/keystone/etc/keystone/policy.d
	PYTHONPATH=$(CURDIR)/debian/tmp/usr/lib/python3/dist-packages oslopolicy-sample-generator \
		--output-file $(CURDIR)/debian/keystone/etc/keystone/policy.d/00_default_policy.yaml \
		--format yaml \
		--namespace keystone

	# Use the policy.d folder
	pkgos-fix-config-default $(CURDIR)/debian/keystone/usr/share/keystone/keystone.conf oslo_policy policy_dirs /etc/keystone/policy.d

	install -D -m 0644 debian/keystone.apparmor $(CURDIR)/debian/keystone/etc/apparmor.d/usr.bin.keystone-all
	dh_apparmor --profile-name=usr.bin.keystone-all

override_dh_sphinxdoc:
ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
	PYTHONPATH=. PYTHON=python3 python3 -m sphinx -b html doc/source $(CURDIR)/debian/keystone-doc/usr/share/doc/keystone-doc/html
	dh_sphinxdoc
endif

override_dh_installman:
ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
	PYTHONPATH=. PYTHON=python3 python3 -m sphinx -b man doc/source doc/build/man
	dh_installman
endif

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

#override_dh_installmenu:
#	dh_installinit --name=keystone-admin
#	dh_installinit --name=keystone-public

## keystone 18.1.0+git2023101210.b59ab8e3

=== requirements.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 WebOb>=1.7.1 # MIT
 Flask!=0.11,>=1.0.2  # BSD
 Flask-RESTful>=0.3.5  # BSD
-cryptography>=2.1 # BSD/Apache-2.0
-SQLAlchemy>=1.1.0 # MIT
-sqlalchemy-migrate>=0.11.0 # Apache-2.0
+cryptography>=2.7 # BSD/Apache-2.0
+SQLAlchemy>=1.3.0 # MIT
+sqlalchemy-migrate>=0.13.0 # Apache-2.0
 stevedore>=1.20.0 # Apache-2.0
 passlib>=1.7.0 # BSD
 python-keystoneclient>=3.8.0 # Apache-2.0
@@ -19,7 +19,7 @@
 oslo.config>=5.2.0 # Apache-2.0
 oslo.context>=2.22.0 # Apache-2.0
 oslo.messaging>=5.29.0 # Apache-2.0
-oslo.db>=4.27.0 # Apache-2.0
+oslo.db>=6.0.0 # Apache-2.0
 oslo.i18n>=3.15.3 # Apache-2.0
 oslo.log>=3.44.0 # Apache-2.0
 oslo.middleware>=3.31.0 # Apache-2.0
@@ -28,10 +28,10 @@
 oslo.upgradecheck>=0.1.0 # Apache-2.0
 oslo.utils>=3.33.0 # Apache-2.0
 oauthlib>=0.6.2 # BSD
-pysaml2>=4.5.0
+pysaml2>=5.0.0
 PyJWT>=1.6.1 # MIT
-dogpile.cache>=0.6.2 # BSD
-jsonschema>=2.6.0 # MIT
+dogpile.cache>=1.0.2 # BSD
+jsonschema>=3.2.0 # MIT
 pycadf!=2.0.0,>=1.1.0 # Apache-2.0
 msgpack>=0.5.0 # Apache-2.0
 osprofiler>=1.4.0 # Apache-2.0

=== debian/changelog ===
keystone (2:18.1.0+git2023101210.b59ab8e3-0ubuntu1~cloud0) focal-victoria; urgency=medium

  * New stable snapshot for OpenStack Victoria (LP: #2039176).

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 12 Oct 2023 10:46:26 -0400

keystone (2:18.1.0-0ubuntu1~cloud0) focal-victoria; urgency=medium

  [ Corey Bryant ]
  * d/gbp.conf: Create stable/victoria branch.

  [ Felipe Reyes ]
  * d/watch: Add missing '/' to the end of the url.
  * New stable point release for OpenStack Victoria (LP: #1962772).

 -- Felipe Reyes <felipe.reyes@canonical.com>  Wed, 02 Mar 2022 16:45:23 -0300

keystone (2:18.0.0-0ubuntu1~cloud0) focal-victoria; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive.

keystone (2:18.0.0-0ubuntu1) groovy; urgency=medium

  * d/control: Update VCS paths for move to lp:~ubuntu-openstack-dev.
  * d/watch: Scope to 18.x series.
  * New upstream release for OpenStack Victoria.
  * d/control: Align (Build-)Depends with upstream.

 -- Chris MacNaughton <chris.macnaughton@ubuntu.com>  Thu, 15 Oct 2020 14:04:15 +0000

keystone (2:18.0.0~b3~git2020091407.0ba9e3a12-0ubuntu1) groovy; urgency=medium

  * d/control: Remove Breaks/Replaces that are older than Focal (LP: #1878419).
  * New upstream snapshot for OpenStack Victoria.
  * d/control: Align (Build-)Depends with upstream.

 -- Chris MacNaughton <chris.macnaughton@canonical.com>  Mon, 14 Sep 2020 07:22:48 +0000

keystone (2:18.0.0~b2~git2020073017.b187dfd05-0ubuntu1) groovy; urgency=medium

  * New upstream snapshot for OpenStack Victoria.
  * d/control: Align (Build-)Depends with upstream.
  * d/control, d/copyright: Update upstream URL.

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 30 Jul 2020 17:03:45 -0400

keystone (2:18.0.0~b1~git2020070209.3eb8cafb8-0ubuntu1) groovy; urgency=medium

  * New upstream snapshot for OpenStack Victoria.
  * d/control: Align (Build-)Depends with upstream.
  * d/control, d/rules: Switch to debhelper compat 12.
  * d/control: Update Standards-Version to 4.5.0.

 -- Corey Bryant <corey.bryant@canonical.com>  Thu, 02 Jul 2020 09:33:09 -0400

keystone (2:17.0.0-0ubuntu1) groovy; urgency=medium

  * d/watch: Scope to 17.x series and get tarballs from opendev.org.
  * d/control: Align (Build-)Depends with upstream.
  * d/p/update-babel-requirement.txt: Dropped now that Babel has been
    dropped from upstream requirements.txt.
  * New upstream release for OpenStack Ussuri (LP: #1877642).

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 13 May 2020 17:10:34 -0400

=== debian/control ===
Source: keystone
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Monty Taylor <mordred@inaugust.com>
Build-Depends:
 apache2-dev,
 debhelper-compat (= 12),
 dh-apache2,
 dh-python,
 openstack-pkg-tools,
 python3-all,
 python3-pbr (>= 2.0.0),
 python3-setuptools,
 python3-sphinx (>= 2.0.0),
 python3-sphinx-feature-classification (>= 0.3.2),
Build-Depends-Indep:
 crudini,
 python3-bashate (>= 0.5.1),
 python3-bcrypt (>= 3.1.3),
 python3-coverage (>= 4.0),
 python3-cryptography (>= 2.7),
 python3-dogpile.cache (>= 1.0.1),
 python3-fixtures (>= 3.0.0),
 python3-flake8-docstrings (>= 0.2.1.post1),
 python3-flask (>= 1.0.2),
 python3-flask-restful (>= 0.3.5),
 python3-freezegun (>= 0.3.6),
 python3-hacking (>= 1.1.0),
 python3-jsonschema (>= 3.2.0),
 python3-jwt (>= 1.6.1),
 python3-keystoneclient (>= 1:3.8.0),
 python3-keystonemiddleware (>= 7.0.0),
 python3-ldap (>= 3.0.0),
 python3-ldappool (>= 2.0.0),
 python3-lxml (>= 4.5.0),
 python3-memcache,
 python3-migrate (>= 0.13.0),
 python3-mock (>= 2.0.0),
 python3-msgpack (>= 0.5.0),
 python3-oauthlib (>= 0.6.2),
 python3-openstackdocstheme (>= 2.2.1),
 python3-os-api-ref (>= 1.4.0),
 python3-oslo.cache (>= 1.26.0),
 python3-oslo.config (>= 1:5.2.0),
 python3-oslo.context (>= 1:2.22.0),
 python3-oslo.db (>= 6.0.0),
 python3-oslo.i18n (>= 3.15.3),
 python3-oslo.log (>= 3.44.0),
 python3-oslo.messaging (>= 5.29.0),
 python3-oslo.middleware (>= 3.31.0),
 python3-oslo.policy (>= 3.0.2),
 python3-oslo.serialization (>= 2.18.0),
 python3-oslo.upgradecheck (>= 0.1.0),
 python3-oslo.utils (>= 3.33.0),
 python3-oslotest (>= 1:3.2.0),
 python3-osprofiler (>= 1.4.0),
 python3-passlib (>= 1.7.0),
 python3-paste (>= 2.0.2),
 python3-pastedeploy (>= 1.5.0),
 python3-pep8,
 python3-pycadf (>= 1.1.0),
 python3-pycodestyle (>= 2.0.0),
 python3-pymongo,
 python3-pymysql,
 python3-pysaml2 (>= 5.0.0),
 python3-requests (>= 2.14.2),
 python3-scrypt (>= 0.8.0),
 python3-sphinxcontrib.apidoc (>= 0.2.0),
 python3-sphinxcontrib.blockdiag (>= 1.5.5),
 python3-sphinxcontrib.seqdiag (>= 0.8.4),
 python3-sqlalchemy (>= 1.3.0),
 python3-stestr (>= 1.0.0),
 python3-stevedore (>= 1:1.20.0),
 python3-tempest (>= 1:17.1.0),
 python3-testresources (>= 2.0.0),
 python3-testtools (>= 2.2.0),
 python3-tz (>= 2013.6),
 python3-webob (>= 1:1.7.1),
 python3-webtest (>= 2.0.27),
Standards-Version: 4.5.0
XS-Python-Version: >= 2.7
Vcs-Browser: https://git.launchpad.net/~ubuntu-openstack-dev/ubuntu/+source/keystone
Vcs-Git: https://git.launchpad.net/~ubuntu-openstack-dev/ubuntu/+source/keystone
Homepage: https://opendev.org/openstack/keystone
Testsuite: autopkgtest-pkg-python

Package: keystone
Architecture: all
Section: python
Depends:
 adduser,
 apache2 | httpd,
 libapache2-mod-wsgi-py3,
 python3-keystone (= ${source:Version}),
 ssl-cert (>= 1.0.12),
 ${misc:Depends},
Recommends:
 ${misc:Recommends},
Description: OpenStack identity service - Daemons
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the daemons.

Package: keystone-common
Architecture: all
Section: python
Depends:
 ${misc:Depends},
Description: OpenStack identity service - Common files
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the common files.

Package: keystone-doc
Architecture: all
Section: doc
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: OpenStack identity service - Documentation
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the documentation.

Package: python3-keystone
Architecture: all
Section: python
Depends:
 keystone-common (= ${source:Version}),
 python3-bcrypt (>= 3.1.3),
 python3-cryptography (>= 2.7),
 python3-dogpile.cache (>= 1.0.1),
 python3-flask (>= 1.0.2),
 python3-flask-restful (>= 0.3.5),
 python3-jsonschema (>= 3.2.0),
 python3-jwt (>= 1.6.1),
 python3-keystoneclient (>= 1:3.8.0),
 python3-keystonemiddleware (>= 7.0.0),
 python3-ldap,
 python3-migrate (>= 0.13.0),
 python3-msgpack (>= 0.5.0),
 python3-oauthlib (>= 0.6.2),
 python3-oslo.cache (>= 1.26.0),
 python3-oslo.config (>= 1:5.2.0),
 python3-oslo.context (>= 1:2.22.0),
 python3-oslo.db (>= 6.0.0),
 python3-oslo.i18n (>= 3.15.3),
 python3-oslo.log (>= 3.44.0),
 python3-oslo.messaging (>= 5.29.0),
 python3-oslo.middleware (>= 3.31.0),
 python3-oslo.policy (>= 3.0.2),
 python3-oslo.serialization (>= 2.18.0),
 python3-oslo.upgradecheck (>= 0.1.0),
 python3-oslo.utils (>= 3.33.0),
 python3-osprofiler (>= 1.4.0),
 python3-passlib (>= 1.7.0),
 python3-paste (>= 2.0.2),
 python3-pastedeploy (>= 1.5.0),
 python3-pbr (>= 2.0.0),
 python3-pycadf (>= 1.1.0),
 python3-pymysql,
 python3-pysaml2 (>= 5.0.0),
 python3-scrypt (>= 0.8.0),
 python3-sqlalchemy (>= 1.3.0),
 python3-stevedore (>= 1:1.20.0),
 python3-tz (>= 2013.6),
 python3-webob (>= 1:1.7.1),
 ${misc:Depends},
 ${python3:Depends},
Suggests:
 python3-ldappool (>= 2.0.0),
 python3-memcache,
Provides:
 ${python3:Provides},
XB-Python-Version: ${python3:Versions}
Description: OpenStack identity service - Python 3 library
 Keystone is a proposed independent authentication service for OpenStack.
 .
 This initial proof of concept aims to address the current use cases in Swift
 and Nova which are:
 .
  * REST-based, token auth for Swift
  * many-to-many relationship between identity and tenant for Nova. Keystone
    does authentication and stuff
 .
 This package contains the Python 3 libraries.

=== debian/rules ===
#!/usr/bin/make -f

# Verbose mode
#export DH_VERBOSE=1

export PYBUILD_NAME=keystone

SHELL := /bin/sh -e

DEBVERS ?= $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
VERSION ?= $(shell echo '$(DEBVERS)' | sed -e 's/^[[:digit:]]*://' -e 's/[-].*//' -e 's/[+].*//' -e 's/~git.*//g' -e 's/~/./g')
export PBR_VERSION=$(VERSION)

include /usr/share/openstack-pkg-tools/pkgos.make

%:
	dh $@ --with apache2,python3 --buildsystem=pybuild

ifeq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	mkdir -p $(CURDIR)/keystone/tests/tmp
	PYTHONPATH=$(CURDIR) pkgos-dh_auto_test --no-py2 'keystone\.tests\.unit.(?!(.*test_sql_upgrade.FullMigration.*))'
endif

override_dh_auto_build:
	dh_auto_build
ifeq (,$(findstring nodocs, $(DEB_BUILD_OPTIONS)))
	mkdir -p $(CURDIR)/doc/build/html
	mkdir -p $(CURDIR)/doc/build/man
	sphinx-build -b man doc/source doc/build/man
	sphinx-build -b html doc/source doc/build/html
endif

override_dh_install:
	rm -rf $(CURDIR)/debian/python3-keystone/usr/etc
	dh_install
	dh_missing --fail-missing
	install -D -m 0600 $(CURDIR)/etc/logging.conf.sample  $(CURDIR)/debian/keystone-common/etc/keystone/logging.conf
	PYTHONPATH=$(CURDIR) oslo-config-generator --config-file=config-generator/keystone.conf \
		--output-file=$(CURDIR)/debian/keystone-common/etc/keystone/keystone.conf
	PYTHONPATH=$(CURDIR) oslopolicy-sample-generator --config-file=config-generator/keystone-policy-generator.conf \
		--output-file=$(CURDIR)/debian/keystone-common/etc/keystone/keystone.policy.yaml
	crudini --merge $(CURDIR)/debian/keystone-common/etc/keystone/keystone.conf < $(CURDIR)/debian/keystone.conf.dist

override_dh_clean:
	rm -rf $(CURDIR)/build $(CURDIR)/keystone.egg-info $(CURDIR)/.cache
	rm -rf $(CURDIR)/keystone/tests/tmp
	rm -rf $(CURDIR)/.testrepository
	rm -rf $(CURDIR)/debian/tmp
	rm -rf $(CURDIR)/doc/build
	# NOTE(adam_g) The following stuff is built in /doc/source.  Safe for now, but
	# should be fixed upstream or updated here post-essex 
	rm -rf $(CURDIR)/doc/source/keystone*.rst
	rm -rf $(CURDIR)/doc/source/modules.rst
	rm -f debian/*.init debian/*.service debian/*.upstart
	dh_clean

override_dh_auto_clean:
	dh_auto_clean
	rm -rf .eggs .testrepository

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

=== debian/watch ===
version=3
opts="uversionmangle=s/\.([a-zA-Z])/~$1/;s/%7E/~/;s/\.0b/~b/;s/\.0rc/~rc/" \
 https://tarballs.opendev.org/openstack/keystone/ keystone-(18\.\d.*)\.tar\.gz

## keystone 19.0.0

=== debian/changelog ===
keystone (2:19.0.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release for OpenStack Wallaby.

 -- Chris MacNaughton <chris.macnaughton@ubuntu.com>  Wed, 14 Apr 2021 14:46:01 +0000

keystone (2:19.0.0~rc1-0ubuntu1) hirsute; urgency=medium

  * d/watch: Scope to 19.x series
  * New upstream release candidate for OpenStack Wallaby.
  * d/control: Align (Build-)Depends with upstream.

 -- Chris MacNaughton <chris.macnaughton@ubuntu.com>  Mon, 29 Mar 2021 14:27:46 +0000

keystone (2:18.0.0+git2021012507.c239cc666-0ubuntu1) hirsute; urgency=medium

  * New upstream snapshot for OpenStack Wallaby.

 -- Chris MacNaughton <chris.macnaughton@ubuntu.com>  Mon, 25 Jan 2021 08:05:30 +0000

keystone (2:18.0.0+git2020120911.b0b93c039-0ubuntu1) hirsute; urgency=medium

  * New upstream snapshot for OpenStack Wallaby.
  * d/control: Align (Build-)Depends with upstream.
  * d/rules: Update PBR_VERSION for new snapshot version format.
  * d/control: Set min BD version of python-oslo.db to 8.5.0+really.8.4.0 to
    align with upper-constraints.

 -- Corey Bryant <corey.bryant@canonical.com>  Wed, 09 Dec 2020 11:51:18 -0500
